{ Created: 2003-09-16 by Berend de Boer

  Test unicode text parameter.

}


library xpunicode;

uses
  Windows,
  SysUtils,
  Classes,
  Odsxp in 'Odsxp.pas';

type

  TXPTextExample = class(TSQLXProc)
    function Execute: Boolean; override;
  end;



{ which version do we support? }

function __GetXpVersion: ULong; cdecl;
begin
  Result := ODS_VERSION;
end;


{ TXPTextExamle }

function TXPTextExample.Execute: Boolean;
var
  buf: array[0..31] of WideChar;
  s: WideString;
  i: Integer;
begin
  DescribeColumn('my column name', SRVNCHAR, 64, SRVNCHAR, 64, @buf);
  s := Params[1];
  for i := Low(buf) to High(buf) do
    buf[i] := ' ';
  Move(s[1], buf, length(s)*2);
  SendRow;
  Result := True;
end;




{ xp_echo }

function xp_textexample(srvproc: PSRV_PROC): SRVRETCODE; cdecl;
const
  ExpectedParams = 1;
var
  xp: TSQLXProc;
begin
  xp := TXPTextExample.Create(srvproc, ExpectedParams);
  Result := xp.Run;
  xp.Free;
end;



exports
  __GetXpVersion index 1,
  xp_textexample index 2;


begin
end.
